Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const path_1 = require("path");
const node_core_1 = require("@speedy/node-core");
const gitRoot = node_core_1.fileSystem.findFileRecursively(".git");
if (!gitRoot) {
    console.log("Not a GIT Repository");
    process.exit(0);
}
const hooksPath = path_1.join(gitRoot, ".git", "hooks");
const commitMsgHookPath = path_1.join(hooksPath, "commit-msg");
let fileStat;
try {
    fileStat = fs_1.lstatSync(commitMsgHookPath);
}
catch (error) {
    // do nothing
}
if (process.argv[2] === "uninstall") {
    uninstall();
}
else {
    install();
}
function install() {
    if (fs_1.existsSync(hooksPath)) {
        if (fileStat && fileStat.isFile()) {
            fs_1.renameSync(commitMsgHookPath, `${commitMsgHookPath}.backup`);
        }
        else {
            uninstall();
        }
    }
    else {
        fs_1.mkdirSync(hooksPath);
    }
    const hookContent = `#!/usr/bin/env node
						require("${path_1.join(__dirname, "hook.js")}");`;
    fs_1.writeFileSync(commitMsgHookPath, hookContent, { mode: fs_1.constants.S_IRWXU });
}
function uninstall() {
    if (fileStat) {
        fs_1.unlinkSync(commitMsgHookPath);
    }
}
